#
# This is the server logic of a Shiny web application. You can run the
# application by clicking 'Run App' above.
#
# Find out more about building applications with Shiny here:
#
#    http://shiny.rstudio.com/
#

# Configurar environment
Sys.setenv(PATH="/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games:/usr/local/games:/snap/bin:/home/uoc/ncbi-blast-2.5.0+/bin:/home/uoc/hmmer-3.1b2/binaries:/home/uoc/edirect:/home/uoc/ps_scan:/home/uoc/ps_scan")

# Opcional: escoger directorio de trabajo
setwd("~/Desktop/R_shiny/shiny_demo")

# Cargar librerías
library(shiny)
library(cazypredict)

# Definir el servidor
shinyServer(function(input, output) {

  getfasta <- eventReactive(input$button1, {
      if(input$org==FALSE){
        type_arg <- input$type
        pattern_arg <- input$pattern
        cazypredict::searchcazy(pattern = pattern_arg, type = type_arg)
      }
      else if(input$org==TRUE){
        type_arg <- input$type
        pattern_arg <- input$pattern
        organism_arg <- input$organismo
        cazypredict::searchcazy(pattern = pattern_arg, type = type_arg, organism = organism_arg)
      }
  })

    output$fasta <- renderPrint({
      getfasta()
    })

  evalue1 <- reactive({as.numeric(input$evalue1)})

  getblast <- eventReactive(input$button2, {
    filename_arg <- input$filename
    evalue1_arg <- evalue1()
    id_arg <- input$identity
    cov_arg <- input$coverage
    hit_arg <- input$hits
    out_arg <- input$outype1
    cazypredict::blastcazy(filename = filename_arg, evalue = evalue1_arg, identity = id_arg, coverage = cov_arg, hits = hit_arg, output = out_arg)
  })

  output$blast <- renderTable({
    getblast()
  },include.rownames=FALSE, spacing = "xs")

  evalue2 <- reactive({as.numeric(input$evalue2)})
  gethmmer <- eventReactive(input$button3, {
    align_arg <- input$align
    evalue2_arg <- evalue2()
    out2_arg <- input$outype2
    cazypredict::hmmercazy(align = align_arg, evalue = evalue2_arg, output = out2_arg)
  })
  output$hmmer <- renderTable({
    gethmmer()
  },include.rownames=FALSE, spacing = "xs")

  getprosite <- eventReactive(input$button4, {
    results_arg <- input$results
    cazypredict::patterncazy(type = results_arg)
  })

  output$prosite <- renderTable({
    getprosite()
  },include.rownames=FALSE, spacing = "xs")
})




